import 'dart:io';

import 'package:protobuf3_parser/src/asset_manager/asset_id.dart';

abstract class AssetWriter {
  Future<void> writeString(AssetId id, String string,
      {FileMode mode = FileMode.write});

  Future<void> writeBytes(AssetId id, List<int> bytes,
      {FileMode mode = FileMode.write});

  Future<void> writeStream(AssetId id, Stream<List<int>> stream,
      {FileMode mode = FileMode.write});

  Future<bool> exists(AssetId id);
}
