import 'dart:io';

import 'package:path/path.dart';
import 'package:protobuf3_parser/src/extensions.dart';
import 'asset_id.dart';
import 'asset_reader.dart';

class DirectoryAssetReader extends AssetReader {
  final Directory _dir;
  DirectoryAssetReader(this._dir);

  File _get(AssetId id) => join(_dir.path, id.path).file;

  @override
  Bytes read(AssetId assetId) => _get(assetId).openRead();

  @override
  bool canRead(AssetId assetId) => _get(assetId).existsSync();
}
