import 'package:antlr4/antlr4.dart' as antlr;
import 'package:protobuf3_parser/protobuf3_parser.dart';

typedef Comments = List<Comment>;

abstract class Element<T extends antlr.ParserRuleContext, P> {
  T ctx;
  Parser parser;

  String get name;
  Comments get comments;
  P? get parentElement;

  Element(this.ctx, this.parser);

  // @override
  // String toString() => toSource();

  Future<String> toSource() => defaultSrcGen.forElement(this);
  Future<String> toMiniSource() => minSrcGen.forElement(this);

  bool get hasComments => comments.isNotEmpty;
  bool get hasParent => parentElement != null;

  bool get isCore => this is CoreTypeMessage;
  bool get isEnum => this is Enum;
}
