import 'package:protobuf3_parser/__generated__/antlr/Protobuf3Parser.dart';
import 'package:protobuf3_parser/protobuf3_parser.dart';

typedef EnumFields = List<EnumField>;

class Enum extends Element<EnumDefContext, Message> {
  Enum(EnumDefContext ctx, Parser parser) : super(ctx, parser);

  @override
  String get name => ctx.enumName()!.text;

  @override
  Message? get parentElement {
    final parent = ctx.parent?.parent?.parent;

    if (parent is MessageDefContext) {
      return Message(parent, parser);
    } else {
      return null;
    }
  }

  EnumFields get fields {
    final l = <EnumField>[];

    final elements = ctx.enumBody()?.enumElements();
    if (elements != null) {
      for (final el in elements) {
        final enumField = el.enumField();
        if (enumField != null) {
          l.add(EnumField(enumField, parser));
        }
      }
    }

    return l;
  }

  @override
  Comments get comments => parser.convertToComments(ctx.comments());
}
