import 'package:protobuf3_parser/__generated__/antlr/Protobuf3Parser.dart';
import 'package:protobuf3_parser/protobuf3_parser.dart';

class EnumField extends Element<EnumFieldContext, Enum> {
  EnumField(EnumFieldContext ctx, Parser parser) : super(ctx, parser);

  int get id => int.parse(ctx.intLit()!.text);

  @override
  String get name => ctx.ident()!.text;

  @override
  Enum? get parentElement {
    final parent = ctx.parent?.parent?.parent;

    if (parent is EnumDefContext) {
      return Enum(parent, parser);
    } else {
      return null;
    }
  }

  @override
  Comments get comments => parser.convertToComments(ctx.comments());
}
