import 'package:protobuf3_parser/__generated__/antlr/Protobuf3Parser.dart';
import 'package:protobuf3_parser/protobuf3_parser.dart';

class Service extends Element<ServiceDefContext, void> {
  Service(ServiceDefContext ctx, Parser parser) : super(ctx, parser);

  @override
  String get name => ctx.serviceName()!.text;

  @override
  void get parentElement {}

  List<ServiceMethod> get methods {
    final l = <ServiceMethod>[];

    for (final el in ctx.serviceElements()) {
      final rpc = el.rpc();
      if (rpc != null) {
        l.add(ServiceMethod(rpc, parser));
      }
    }

    return l;
  }

  @override
  Comments get comments => parser.convertToComments(ctx.comments());
}
