import 'package:protobuf3_parser/__generated__/antlr/Protobuf3Parser.dart';
import 'package:protobuf3_parser/protobuf3_parser.dart';

class ServiceMethod extends Element<RpcContext, Service> {
  ServiceMethod(RpcContext ctx, Parser parser) : super(ctx, parser);

  @override
  String get name => ctx.rpcName()!.text;

  @override
  get parentElement => throw UnimplementedError();

  bool get isStreamRequest => ctx.requestStream != null;

  Future<Message> get request async {
    final typeStr = ctx.request!.messageName()!.text;

    // search in toplevel messages.
    await for (final message in parser.messages) {
      if (message.name == typeStr) {
        return message;
      }
    }

    // search in other toplevel files.
    await for (final file in parser.files) {
      await for (final message in file.messages) {
        if (message.name == typeStr) {
          return message;
        }
      }
    }

    throw Exception("Couldn't find !");
  }

  bool get isStreamResponse => ctx.responseStream != null;

  Future<Message> get response async {
    final typeStr = ctx.response!.messageName()!.text;

    // search in toplevel messages.
    await for (final message in parser.messages) {
      if (message.name == typeStr) {
        return message;
      }
    }

    // search in other toplevel files.
    await for (final file in parser.files) {
      await for (final message in file.messages) {
        if (message.name == typeStr) {
          return message;
        }
      }
    }

    throw Exception("Couldn't find !");
  }

  @override
  Comments get comments => parser.convertToComments(ctx.comments());
}
