from os import linesep
from os.path import abspath, dirname, join, basename

THIS_FILE     = abspath(__file__)
THIS_DIR      = dirname(THIS_FILE)
ROOT_DIR      = dirname(THIS_DIR)

OUT_FILE      = join(ROOT_DIR, "lib/src/parser/core_types.g.dart")

# https://developers.google.com/protocol-buffers/docs/proto3#scalar
TYPES = [
  "double",
  "float",
  "int32",
  "int64",
  "uint32",
  "uint64",
  "sint32",
  "sint64",
  "fixed32",
  "fixed64",
  "sfixed32",
  "sfixed64",
  "bool",
  "string",
  "bytes"
]

class FBuffer():
  def __init__(self, path: str) -> None:
    self.path   = path
    self.f      = open(path, "w")
  def w(self, string: str):
    self.f.write(string)
    self.f.flush()
  def l(self, string: str):
    self.w(f"{string}{linesep}")


f = FBuffer(OUT_FILE)
f.l("/// Auto generated. Do not edit by hand.")
f.l(f"/// Modify and rerun the `{THIS_FILE[len(ROOT_DIR):]}` file to update it.")
f.l("import 'dart:core' as $core;")
f.l("import 'package:protobuf3_parser/protobuf3_parser.dart' as $pp3;")

f.l("class CoreTypes {")
for type in TYPES:
  f.l(f'\tstatic const $core.String {type} = "{type}";');

f.w("\tstatic const $core.List<$core.String> values = [")
for i in range(len(TYPES)):
  type      = TYPES[i]
  is_last   = len(TYPES) - 1 == i
  f.w(type);
  if not is_last: f.w(",")
f.l("];")

f.l("}")


# isCore___ extensions 
f.l("extension ElementExtensions on $pp3.Element {")
for type in TYPES:
  f.l(f"\t$core.bool get isCore{type[0].upper()}{type[1:]} => isCore && name == CoreTypes.{type};")
f.l("}")
