from os.path import abspath, dirname, join
from os import linesep, walk


THIS_FILE           = abspath(__file__)
THIS_DIR            = dirname(THIS_FILE)
ROOT_DIR            = dirname(THIS_DIR)
LIB_DIR             = join(ROOT_DIR, "lib")


DIRS                = [
  join(ROOT_DIR, "lib/src/model"),
  join(ROOT_DIR, "lib/src/gen")
]




class FBuffer():
  def __init__(self, path: str) -> None:
    self.path   = path
    self.f      = open(path, "w")
    self.l(f"// Auto generated by '{THIS_FILE[len(ROOT_DIR)+1:]}'. Do not modify.")
  def w(self, string: str):
    self.f.write(string)
    self.f.flush()
  def l(self, string: str):
    self.w(f"{string}{linesep}")


ALL_EXPORTS_FILE    = join(ROOT_DIR, "lib/exports.g.dart")
all_f               = FBuffer(ALL_EXPORTS_FILE)


def generate_exports_for(dir: str) -> None:
  gen_file    = join(dir, "exports.dart")
  f = FBuffer(gen_file)

  for root, dirs, files in walk(dir):
      for file_name in files:
          if not file_name.endswith(".dart"): continue
          file_path = join(root, file_name)
          if file_path == gen_file: continue

          f.l(f"export '{file_path[len(dir)+1:]}';")

  all_f.l(f"export '{dir[len(LIB_DIR)+1:]}/exports.dart';")


for dir in DIRS:
  generate_exports_for(dir)
